'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports['default'] = createContainer;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _utilsGetDisplayName = require('../utils/getDisplayName');

var _utilsGetDisplayName2 = _interopRequireDefault(_utilsGetDisplayName);

var _utilsCreateAdaptorShape = require('../utils/createAdaptorShape');

var _utilsCreateAdaptorShape2 = _interopRequireDefault(_utilsCreateAdaptorShape);

var adaptorShape = (0, _utilsCreateAdaptorShape2['default'])(_react.PropTypes);

function createContainer(DecoratedComponent, specs) {
  var displayName = 'AdrenalineContainer(' + (0, _utilsGetDisplayName2['default'])(DecoratedComponent) + ')';

  (0, _invariant2['default'])(specs !== null && specs !== undefined, displayName + ' requires configuration.');
  (0, _invariant2['default'])(typeof specs.queries === 'function', 'You have to define \'queries\' as a function.');

  return (function (_Component) {
    _inherits(_class, _Component);

    _createClass(_class, null, [{
      key: 'displayName',
      value: displayName,
      enumerable: true
    }, {
      key: 'DecoratedComponent',
      value: DecoratedComponent,
      enumerable: true
    }, {
      key: 'contextTypes',
      value: {
        renderLoading: _react.PropTypes.func.isRequired,
        adaptor: adaptorShape.isRequired
      },
      enumerable: true
    }]);

    function _class(props, context) {
      var _this = this;

      _classCallCheck(this, _class);

      _get(Object.getPrototypeOf(_class.prototype), 'constructor', this).call(this, props, context);

      this.setArgs = function (nextArgs, cb) {
        _this.fetch(nextArgs, cb);
      };

      this.fetch = function (nextArgs, cb) {
        if (nextArgs === undefined) nextArgs = {};
        var adaptor = _this.context.adaptor;
        var queries = specs.queries;

        var args = _extends({}, _this.state.args, nextArgs);

        adaptor.resolve(queries, args, _this.isDataLoaded).then(function (data) {
          _this.setState({
            data: _extends({}, _this.state.data, data),
            args: args
          }, cb);
        })['catch'](cb);
      };

      var adaptor = context.adaptor;

      //DecoratedComponent.prototype.shouldComponentUpdate = adaptor.shouldComponentUpdate;

      var initialArgs = specs.args(props);

      this.state = {
        data: {},
        args: specs.args(props)
      };

      var dataKeys = Object.keys(specs.queries(initialArgs));
      var propTypes = DecoratedComponent.propTypes;

      var requiredKeys = dataKeys.filter(function (key) {
        return propTypes[key] && !propTypes[key].isRequired;
      });

      this.isDataLoaded = function () {
        var data = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
        return requiredKeys.every(function (key) {
          return data[key] !== null && data[key] !== undefined;
        });
      };
    }

    _createClass(_class, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var adaptor = this.context.adaptor;

        this.unsubscribe = adaptor.subscribe(this.fetch);
        this.fetch();
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.unsubscribe();
      }
    }, {
      key: 'render',
      value: function render() {
        var renderLoading = this.context.renderLoading;
        var _state = this.state;
        var data = _state.data;
        var args = _state.args;

        if (!this.isDataLoaded(data)) {
          return renderLoading();
        }

        return _react2['default'].createElement(DecoratedComponent, _extends({}, this.props, data, {
          args: args,
          setArgs: this.setArgs }));
      }
    }]);

    return _class;
  })(_react.Component);
}

module.exports = exports['default'];
//# sourceMappingURL=createContainer.js.map