'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports['default'] = createSmartComponent;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _GraphQLConnector = require('./GraphQLConnector');

var _GraphQLConnector2 = _interopRequireDefault(_GraphQLConnector);

var _utilsCreateStoreShape = require('../utils/createStoreShape');

var _utilsCreateStoreShape2 = _interopRequireDefault(_utilsCreateStoreShape);

var _utilsShadowEqualScalar = require('../utils/shadowEqualScalar');

var _utilsShadowEqualScalar2 = _interopRequireDefault(_utilsShadowEqualScalar);

var _utilsGetDisplayName = require('../utils/getDisplayName');

var _utilsGetDisplayName2 = _interopRequireDefault(_utilsGetDisplayName);

var _utilsNormalize = require('../utils/normalize');

var _utilsNormalize2 = _interopRequireDefault(_utilsNormalize);

var _utilsRequest = require('../utils/request');

var _utilsRequest2 = _interopRequireDefault(_utilsRequest);

var _utilsBindMutations = require('../utils/bindMutations');

var _utilsBindMutations2 = _interopRequireDefault(_utilsBindMutations);

var _constants = require('../constants');

function createSmartComponent(DecoratedComponent, specs) {
  var displayName = 'SmartComponent(' + (0, _utilsGetDisplayName2['default'])(DecoratedComponent) + ')';

  return (function (_Component) {
    _inherits(_class, _Component);

    _createClass(_class, null, [{
      key: 'displayName',
      value: displayName,
      enumerable: true
    }, {
      key: 'DecoratedComponent',
      value: DecoratedComponent,
      enumerable: true
    }, {
      key: 'contextTypes',
      value: {
        store: (0, _utilsCreateStoreShape2['default'])(_react.PropTypes).isRequired,
        parsedSchema: _react.PropTypes.object.isRequired,
        Loading: _react.PropTypes.func.isRequired,
        endpoint: _react.PropTypes.string.isRequired
      },
      enumerable: true
    }, {
      key: 'childContextTypes',
      value: {
        update: _react.PropTypes.func.isRequired
      },
      enumerable: true
    }]);

    function _class(props, context) {
      _classCallCheck(this, _class);

      _get(Object.getPrototypeOf(_class.prototype), 'constructor', this).call(this, props, context);
      this.pending = [];
      this.mutations = (0, _utilsBindMutations2['default'])(context.endpoint, context.parsedSchema, specs.mutations || {}, context.store.dispatch);
      this.onChildNeedUpdate();
    }

    _createClass(_class, [{
      key: 'getChildContext',
      value: function getChildContext() {
        return {
          update: this.onChildNeedUpdate.bind(this)
        };
      }
    }, {
      key: 'shouldComponentUpdate',
      value: function shouldComponentUpdate(nextProps) {
        return !(0, _utilsShadowEqualScalar2['default'])(this.props, nextProps);
      }
    }, {
      key: 'onChildNeedUpdate',
      value: function onChildNeedUpdate() {
        var _this = this;

        var _context = this.context;
        var parsedSchema = _context.parsedSchema;
        var endpoint = _context.endpoint;
        var store = _context.store;
        var dispatch = store.dispatch;

        var query = specs.query();
        if (this.pending.indexOf(query) > -1) return;
        this.pending = this.pending.concat(query);

        (0, _utilsRequest2['default'])(endpoint, { query: query }).then(function (json) {
          dispatch({
            type: _constants.ACTION_TYPE,
            payload: (0, _utilsNormalize2['default'])(parsedSchema, json.data)
          });
          _this.pending = _this.pending.filter(function (p) {
            return p === _utilsRequest2['default'];
          });
        })['catch'](function (err) {
          dispatch({ type: _constants.ACTION_TYPE, payload: err, error: true });
          _this.pending = _this.pending.filter(function (p) {
            return p === _utilsRequest2['default'];
          });
        });
      }
    }, {
      key: 'renderComponent',
      value: function renderComponent(state) {
        (0, _invariant2['default'])(DecoratedComponent.propTypes !== undefined, 'You have to declare propTypes for %s', displayName);

        var keys = Object.keys(DecoratedComponent.propTypes || {});
        var dataLoaded = keys.every(function (key) {
          if (key === 'mutations') {
            return true;
          }
          return state.hasOwnProperty(key) && state[key] !== null;
        });

        var Loading = this.context.Loading;

        if (!dataLoaded) {
          return _react2['default'].createElement(Loading, null);
        }

        return _react2['default'].createElement(DecoratedComponent, _extends({}, this.props, state, {
          mutations: this.mutations }));
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2['default'].createElement(
          _GraphQLConnector2['default'],
          { select: function (state) {
              return state;
            }, query: specs.query },
          this.renderComponent.bind(this)
        );
      }
    }]);

    return _class;
  })(_react.Component);
}

module.exports = exports['default'];