'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = bindMutations;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodash = require('lodash');

var _request = require('./request');

var _request2 = _interopRequireDefault(_request);

var _normalize = require('./normalize');

var _normalize2 = _interopRequireDefault(_normalize);

var _constants = require('../constants');

function bindMutations(endpoint, parsedSchema, mutations, dispatch) {
  return (0, _lodash.mapValues)(mutations, function (m) {
    return function () {
      (0, _request2['default'])(endpoint, { query: m.apply(undefined, arguments) }).then(function (json) {
        var payload = (0, _normalize2['default'])(parsedSchema, json.data);
        console.log(payload);
        dispatch({ type: _constants.ACTION_TYPE, payload: payload });
      })['catch'](function (err) {
        dispatch({ type: _constants.ACTION_TYPE, payload: err, error: true });
      });
    };
  });
}

module.exports = exports['default'];