'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = createCache;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _redux = require('redux');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _merge = require('./merge');

var _merge2 = _interopRequireDefault(_merge);

var _constants = require('../constants');

var composedStore = (0, _redux.compose)((0, _redux.applyMiddleware)(_reduxThunk2['default']), _redux.createStore);

function createCache(parsedSchema) {
  var reducer = (0, _redux.combineReducers)(Object.keys(parsedSchema).reduce(function (acc, key) {
    return _extends({}, acc, _defineProperty({}, key, createReducer(key)));
  }, {}));
  return composedStore(reducer);
}

function createReducer(key) {
  return function (state, action) {
    if (state === undefined) state = {};
    var type = action.type;
    var payload = action.payload;
    var error = action.error;

    if (error) {
      return state;
    }

    switch (type) {
      case _constants.ACTION_TYPE:
        return (0, _merge2['default'])(state, payload[key] || {});
      default:
        return state;
    }
  };
}
module.exports = exports['default'];